// Definitionen fr den PCF8574
//#define PCF8574_MainAdrWrite   0x70  // Die Adresse 70 fr Schreiben, wenn Pin A0-2 am PCF8574 auf GND liegt
//#define PCF8574_MainAdrRead    0x71  // Die Adresse 71 fr Lesen, wenn Pin A0-2 am PCF8574 auf GND liegt
//#define TWGCE 	0x01               //enables the recognition of a General Call given over the Two-wire Serial Bus

unsigned char TWIlcd_data(unsigned char p, unsigned char MAINADR, unsigned char SUBADR);
unsigned char TWIlcd_command(unsigned char p,unsigned char MAINADR, unsigned char SUBADR);

#define LCD_RS  0b00000001
#define LCD_RW  0b00000010
#define	LCD_EN	0b00000100

#define LCD_DB0  0b00000001
#define LCD_DB1  0b00000010
#define LCD_DB2  0b00000100
#define LCD_DB3  0b00001000
#define LCD_DB4  0b00010000
#define LCD_DB5  0b00100000
#define LCD_DB6  0b01000000
#define LCD_DB7  0b10000000

#define LCD_LINE1          0x00     /* DDRAM Adresse Zeile 1 */
#define LCD_LINE2          0x40     /* DDRAM Adresse Zeile 2 */
#define LCD_LINE3          0x14     /* DDRAM Adresse Zeile 3 */
#define LCD_LINE4          0x54     /* DDRAM Adresse Zeile 4 */

static unsigned char lcd_line[4]={LCD_LINE1,LCD_LINE2,LCD_LINE3,LCD_LINE4};

unsigned char i2c;
#include "i2c.h"

unsigned char TWIlcd_data(unsigned char p, unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR)
{
unsigned char c;

// RS 	P0
// R/W	P1
// EN	P2

// DB4	P4
// DB5	P5
// DB6	P6
// DB7	P7

//printf("\n\rDATA=%02x ",p);
c=p & 0xf0;
//printf(" DATA=%02x ",c);
c=c | LCD_RS | LCD_EN; // RS setzen
#asm("cli")
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_us(50); // 50us delay
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
c=p<<4;
//printf("\n\rDATA=%02x ",c);
c=c & 0xf0;
//printf(" DATA=%02x ",c);
c=c | LCD_RS | LCD_EN; // RS setzen
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_us(50); // 50us delay
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
#asm("sei")   /* enable interrupts */
return(st);
}

unsigned char TWIlcd_command(unsigned char p, unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR)
{
unsigned char c,hn,ln;

// RS 	P0
// R/W	P1
// EN	P2

// DB4	P4
// DB5	P5
// DB6	P6
// DB7	P7

c=0;
// bedingt durch den Anschluss des LCD an den PCF8574 im 4 Bit Modus
ln=(p<<4)&0xf0;
hn=p&0xf0;
c=hn|LCD_EN;
//printf("\n\rCOMM hn=%02x ln=%02x",hn, ln);
#asm("cli")
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_us(50); // 50us delay
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
c=ln|LCD_EN;
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_us(50); // 50us delay
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_us(50); // 50us delay
#asm("sei")   /* enable interrupts */
return(st);
}

//Initialisierung: muss ganz am Anfang des Programms aufgerufen werden
void TWIlcd_init(unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR)
{
unsigned char c,st;

//30h,30h,30h,20h, 28h,08h,01h,06h,0fh
//30h,30h,30h,20h, 28h,08h,01h,06h,02h

printf("\n\rinitialisiere TWI LCD");
TWI_init(100);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,0);

delay_ms(250);
c=LCD_DB5 | LCD_DB4 | LCD_EN;
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(5);
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(5);
c=LCD_DB5 | LCD_DB4 | LCD_EN;
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(5);
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(5);
c=LCD_DB5 | LCD_DB4 | LCD_EN;
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(5);
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(5);
c=LCD_DB5 | LCD_EN;
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(5);
c&=(~LCD_EN);
st=TWI_write(PCF8574_WRITEADR,PCF8574_SUBADR,c);
delay_ms(16);



c=LCD_DB5|LCD_DB3;
st=TWIlcd_command(c,PCF8574_WRITEADR, PCF8574_SUBADR);
delay_ms(16);

c=LCD_DB3 | LCD_DB2;
st=TWIlcd_command(c,PCF8574_WRITEADR, PCF8574_SUBADR);
delay_ms(16);

c=LCD_DB0;
st=TWIlcd_command(c,PCF8574_WRITEADR, PCF8574_SUBADR);
delay_ms(64);
c=LCD_DB2 | LCD_DB1;
st=TWIlcd_command(c,PCF8574_WRITEADR, PCF8574_SUBADR);
delay_ms(16);
c=LCD_DB1;
st=TWIlcd_command(c,PCF8574_WRITEADR, PCF8574_SUBADR);
delay_ms(16);
//c='S';
//st=TWIlcd_data(c,PCF8574_WRITEADR, PCF8574_SUBADR);

printf("\n\rinitialisieren TWI LCD fertig");
}

void TWIlcd_clear(unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR)
{
unsigned char c;

//c=0b00000001;
c=LCD_DB0;               //
st=TWIlcd_command(c,PCF8574_WRITEADR, PCF8574_SUBADR);
delay_ms(64);
TWIlcd_gotoxy(PCF8574_WRITEADR, PCF8574_SUBADR, 0, 0);
delay_ms(5);

}

void TWIlcd_gotoxy(unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR, unsigned char col, unsigned char row)
{
unsigned char c;

c=LCD_DB7+lcd_line[row]+col;
st=TWIlcd_command(c,PCF8574_WRITEADR, PCF8574_SUBADR);
delay_ms(5);
}

void TWIlcd_putsf(unsigned char flash *p, unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR)
{
unsigned int i;

for(i=0;p[i]>0;i++)
    {
    TWIlcd_data(p[i], PCF8574_WRITEADR, PCF8574_SUBADR);
    if(i>63)
        break;
    }
}

void TWIlcd_puts(unsigned char *p, unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR)
{
unsigned int i;

for(i=0;p[i]>0;i++)
    {
    TWIlcd_data(p[i], PCF8574_WRITEADR, PCF8574_SUBADR);
    if(i>63)
        break;
    }
}

void TWIlcd_putc(unsigned char p, unsigned char PCF8574_WRITEADR, unsigned char PCF8574_SUBADR)
{
TWIlcd_data(p, PCF8574_WRITEADR, PCF8574_SUBADR);
}

