// Definitionen fr den PCF8574
// PCF8574 	ADR 40
// PCF8574A	ADR 70
#define PCF8574_MainAdrWrite   0x40             // Die Adresse 40/70 fr Schreiben PCF8574
#define PCF8574_MainAdrRead    0x41             // Die Adresse 41/71 fr Lesen PCF8574
#define PCF8574A_MainAdrWrite  0x70             // Die Adresse 40/70 fr Schreiben PCF8574
#define PCF8574A_MainAdrRead   0x71             // Die Adresse 41/71 fr Lesen PCF8574
#define TWI_LCDAdr             0x0              // Subadresse des PCF8574/A
#define TWI_SUBAdr1            0x1              // Subadresse des PCF8574/A

#define SET_DATE_TIME          0x01             // Anfangsadresse im PCF8583 Register zum Beschreiben
#define GET_DATE_TIME          0x02             // Anfangsadresse im PCF8583 Register zum Lesen
#define SET_ALARM              0x09             // Mit dieser Adresse beginnt das Setzen der Alarmzeit
#define GET_ALARM              0x0A             // Durch diese Adresse kann die Alarmzeit abgefragt werden

/* quartz crystal frequency [Hz] */
#define fcpu 16000000L

void TWIlcd_init(unsigned char MAINADR, unsigned char SUBADR);
void TWIlcd_clear(unsigned char MAINADR, unsigned char SUBADR);
void TWIlcd_gotoxy(unsigned char MAINADR, unsigned char SUBADR, unsigned char col, unsigned char row);
void TWIlcd_putsf(unsigned char flash *p, unsigned char MAINADR, unsigned char SUBADR);
void TWIlcd_puts(unsigned char *p, unsigned char MAINADR, unsigned char SUBADR);
void TWIlcd_putc(unsigned char p, unsigned char MAINADR, unsigned char SUBADR);
void cli(void);
void sei(void);

#include <mega32.h>
#include <string.h>
#include <math.h>
//#include "uart.c"

#include <stdio.h>
#include <delay.h>
#include <stdlib.h>

// 2 Wire bus interrupt service routine
interrupt [TWSI] void twi_isr(void)
{
   //hier wird das TWSR darauf geprft, ob 0x80 darin steht, dieser Wert bedeutet, dass Daten
   //empfangen wurden, 0x60 wrde zB bedeuten, dass er addressiert wurde und dies besttigt hat
   if((TWSR & 0b11111000) == 0x80){
      //hier Code einfgen, der bearbeitet werden soll, die empfangenen Daten kann man aus
      //TWDR auslesen
   }
   //wenn der Interrupt ausgelst wird, wird der TWI des C blockiert, damit man die Daten
   //verarbeiten kann
   //um ihn wieder zu aktivieren, muss man eben folgenden Befehl ausfhren
   TWCR |= 0b10000000;
}


void main(void)
{

TWIlcd_init(PCF8574A_MainAdrWrite, TWI_LCDAdr);
TWIlcd_clear(PCF8574A_MainAdrWrite,TWI_LCDAdr);
TWIlcd_gotoxy(PCF8574A_MainAdrWrite, TWI_LCDAdr, 10, 1);
TWIlcd_putsf("Peter",PCF8574A_MainAdrWrite,TWI_LCDAdr);
}
